<?php

namespace Teknisa\CADFIN\Controllers;

use Teknisa\CADFIN\Controllers\TeknisaCrud;
use Teknisa\CADFIN\Services\Rec41100TipoCtReceberService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class TipoctreceberClassfinancContctbl extends TeknisaCrud{

  protected $dataSourceName = 'tipoctreceber_classfinanc_contctbl';
  
  protected $parameterBag;
  protected $crudService;
  protected $service;
  
  public function __construct($crudService, ParameterBag $parameterBag, Rec41100TipoCtReceberService $service, EntityManager $entityManager) {
    $this->entityManager    = $entityManager;
    $this->service = $service;
    parent::__construct($crudService, $parameterBag);
  }
  
  public function save(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'tipoctreceber_classfinanc_contctbl';
    $row = $request->getDataSet()->getRows()[0];
    
    if(!isset($row['CDHISTPADR'])) {
      $row['CDHISTPADR'] = null;
      $newDataSet = new DataSet($this->dataSourceName, array($row));
      $newRequest = new DTO\Request\DataSet($newDataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
      parent::save($newRequest, $response);
    } else {
      parent::save($request, $response);
    }
  }
  
  public function getNvMaxContctbl(DTO\Request $request, DTO\Response $response) {
    
    $result = $this->service->getNvMaxContctbl();
    $dataSet = new DataSet('paramgeral', $result);
    $response->addDataSet($dataSet); 
    
  }
  
  public function saveEmpresa(DTO\Request $request, DTO\Response $response) {
    try {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
            
        $row        = $request->getRow();
        $this->service->saveEmpresa($row);
        
        $this->entityManager->commit();
        
    } catch (\Exception $e) {
        $this->entityManager->rollback();
        $response->setError(new Error($e->getMessage(), $e->getCode()));
    }
    
  }
  
  public function cadastroAutomaticoEmpresa(DTO\Request $request, DTO\Response $response) {
    try {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
            
        $row        = $request->getRow();
        $this->service->cadastroAutomaticoEmpresa($row);
        
        $this->entityManager->commit();
        
    } catch (\Exception $e) {
        $this->entityManager->rollback();
        $response->setError(new Error($e->getMessage(), $e->getCode()));
    }
    
  }
  
}