<?php

namespace Teknisa\CADFIN\Factories;

use Doctrine\ORM\EntityManager;

class Rec41100TipoCtReceberFactory {
  
  protected $connection;

  public function __construct(EntityManager $entityManager) {
    $this->connection = $entityManager->getConnection();
  }
    
  public function findNvMaxContctbl() { 
    
    $sql = "SELECT LENGTH(REGEXP_REPLACE(CDPICTCCTB, '[^\.]')) + 1 AS NVMAXCONTCTBL FROM PARAMGERAL";
    
    $std = $this->connection->prepare($sql);
    $params = array();
    $std->execute($params);
    
    return $std->fetch();
    
  }
  
  public function selectEmpresa($cdempresa,$cdtpctreceb) { 
    
    $sql = "SELECT * FROM EMPRTPCTREC 
             WHERE CDEMPRESA = :CDEMPRESA 
             AND CDTPCTRECEB = :CDTPCTRECEB";
    
    $std = $this->connection->prepare($sql);
    
    $params = array(
        "CDEMPRESA"       => $cdempresa,
        "CDTPCTRECEB"     => $cdtpctreceb,
    );
    
    $std->execute($params);
    
    return $std->fetch();
    
  }
  
  public function saveEmpresa($params) {
        // Query a ser executada.
        $sql = "INSERT INTO EMPRTPCTREC (CDEMPRESA,
                                        CDOPERINCLUSAO, 
                                        CDOPERULTATU, 
                                        CDTPCTRECEB, 
                                        DTINCLUSAO, 
                                        DTULTATU, 
                                        IDATIVO, 
                                        NRORG, 
                                        NRORGINCLUSAO, 
                                        NRORGULTATU) 
                              VALUES (  :CDEMPRESA, 
                                        :CDOPERINCLUSAO, 
                                        :CDOPERULTATU, 
                                        :CDTPCTRECEB, 
                                        :DTINCLUSAO, 
                                        :DTULTATU, 
                                        :IDATIVO, 
                                        :NRORG, 
                                        :NRORGINCLUSAO, 
                                        :NRORGULTATU)";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    } 
  
  public function deleteEmpresa($cdtpctreceb) {
        // Query a ser executada.
        $sql = "DELETE FROM EMPRTPCTREC WHERE CDTPCTRECEB = :CDTPCTRECEB";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDTPCTRECEB"     => $cdtpctreceb,
        );
    
    
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    } 
  
}
